Package org.opencv.ximgproc

## Class SuperpixelSLIC

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.ximgproc.SuperpixelSLIC

-     public class SuperpixelSLIC
      extends Algorithm

  Class implementing the SLIC (Simple Linear Iterative Clustering) superpixels algorithm described in CITE: Achanta2012. SLIC (Simple Linear Iterative Clustering) clusters pixels using pixel channels and image plane space to efficiently generate compact, nearly uniform superpixels. The simplicity of approach makes it extremely easy to use a lone parameter specifies the number of superpixels and the efficiency of the algorithm makes it very practical. Several optimizations are available for SLIC class: SLICO stands for "Zero parameter SLIC" and it is an optimization of baseline SLIC described in CITE: Achanta2012. MSLIC stands for "Manifold SLIC" and it is an optimization of baseline SLIC described in CITE: Liu_2017_IEEE.

- - ### Field Summary

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `SuperpixelSLIC​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static SuperpixelSLIC` | `__fromPtr__​(long addr)` |
    `void` | `enforceLabelConnectivity()` | Enforce label connectivity.
    `void` | `enforceLabelConnectivity​(int min_element_size)` | Enforce label connectivity.
    `protected void` | `finalize()` |
    `void` | `getLabelContourMask​(Mat image)` | Returns the mask of the superpixel segmentation stored in SuperpixelSLIC object.
    `void` | `getLabelContourMask​(Mat image, boolean thick_line)` | Returns the mask of the superpixel segmentation stored in SuperpixelSLIC object.
    `void` | `getLabels​(Mat labels_out)` | Returns the segmentation labeling of the image.
    `int` | `getNumberOfSuperpixels()` | Calculates the actual amount of superpixels on a given segmentation computed and stored in SuperpixelSLIC object.
    `void` | `iterate()` | Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSLIC object.
    `void` | `iterate​(int num_iterations)` | Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSLIC object.

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, empty, getDefaultName, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SuperpixelSLIC

          protected SuperpixelSLIC​(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static SuperpixelSLIC __fromPtr__​(long addr)

    - #### getNumberOfSuperpixels

          public int getNumberOfSuperpixels()

      Calculates the actual amount of superpixels on a given segmentation computed and stored in SuperpixelSLIC object.
      Returns:
        automatically generated

    - #### enforceLabelConnectivity

          public void enforceLabelConnectivity​(int min_element_size)

      Enforce label connectivity.
      Parameters:
        `min_element_size` - The minimum element size in percents that should be absorbed into a bigger superpixel. Given resulted average superpixel size valid value should be in 0-100 range, 25 means that less then a quarter sized superpixel should be absorbed, this is default. The function merge component that is too small, assigning the previously found adjacent label to this component. Calling this function may change the final number of superpixels.

    - #### enforceLabelConnectivity

          public void enforceLabelConnectivity()

      Enforce label connectivity. superpixel. Given resulted average superpixel size valid value should be in 0-100 range, 25 means that less then a quarter sized superpixel should be absorbed, this is default. The function merge component that is too small, assigning the previously found adjacent label to this component. Calling this function may change the final number of superpixels.

    - #### getLabelContourMask

          public void getLabelContourMask​(Mat image,
                                          boolean thick_line)

      Returns the mask of the superpixel segmentation stored in SuperpixelSLIC object.
      Parameters:
        `image` - Return: CV_8U1 image mask where -1 indicates that the pixel is a superpixel border, and 0 otherwise.
        `thick_line` - If false, the border is only one pixel wide, otherwise all pixels at the border are masked. The function return the boundaries of the superpixel segmentation.

    - #### getLabelContourMask

          public void getLabelContourMask​(Mat image)

      Returns the mask of the superpixel segmentation stored in SuperpixelSLIC object.
      Parameters:
        `image` - Return: CV_8U1 image mask where -1 indicates that the pixel is a superpixel border, and 0 otherwise. are masked. The function return the boundaries of the superpixel segmentation.

    - #### getLabels

          public void getLabels​(Mat labels_out)

      Returns the segmentation labeling of the image. Each label represents a superpixel, and each pixel is assigned to one superpixel label.
      Parameters:
        `labels_out` - Return: A CV_32SC1 integer array containing the labels of the superpixel segmentation. The labels are in the range [0, getNumberOfSuperpixels()]. The function returns an image with the labels of the superpixel segmentation. The labels are in the range [0, getNumberOfSuperpixels()].

    - #### iterate

          public void iterate​(int num_iterations)

      Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSLIC object. This function can be called again without the need of initializing the algorithm with createSuperpixelSLIC(). This save the computational cost of allocating memory for all the structures of the algorithm.
      Parameters:
        `num_iterations` - Number of iterations. Higher number improves the result. The function computes the superpixels segmentation of an image with the parameters initialized with the function createSuperpixelSLIC(). The algorithms starts from a grid of superpixels and then refines the boundaries by proposing updates of edges boundaries.

    - #### iterate

          public void iterate()

      Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSLIC object. This function can be called again without the need of initializing the algorithm with createSuperpixelSLIC(). This save the computational cost of allocating memory for all the structures of the algorithm. The function computes the superpixels segmentation of an image with the parameters initialized with the function createSuperpixelSLIC(). The algorithms starts from a grid of superpixels and then refines the boundaries by proposing updates of edges boundaries.

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `Algorithm`
      Throws:
        `java.lang.Throwable`